

;************ Example platform to experiment with the macros ****************** 

; ************** We will use the ATmega48 microcontroller ******************

#define reljump (0)				; The ATmega48 does not support JMP instructions, only RJMP
								; CAUTION: DEFINEs must precede including of the macro sources

.include "m48def.inc"			
.include "AVR_basic_macros_4_02.asm"
.include "AVR_alternative_basic_macros_4_01.asm"



; *********************** Der SRAM **************************

.dseg

.org sram_start

; Declare bytes, words and arrays here


; ********************** The main program *****************************************



.CSEG

.ORG 0x0000

rjmp begin
rjmp extint0
rjmp extint1
rjmp pcint_0
rjmp pcint_1
rjmp pcint_2
rjmp wdt
rjmp tim2compa
rjmp tim2compb
rjmp tim2ovf
rjmp tim1capt
rjmp tim1compa
rjmp timicompb
rjmp tim1ovf
rjmp tim0compa
rjmp tim0compb
rjmp tim0ovf
rjmp spistc
rjmp usartrxc
rjmp usartudre
rjmp usarttxc
rjmp adcrdy
rjmp eeready
rjmp anacomp
rjmp twi
rjmp spmrdy


begin:

gwlit spl,ramend-8			; establish the stack pointer

lita ramend-sram_start+1	; number of SRAM bytes (byte count) to A

litz sram_start				; SRAM start address to Z

clearram1:					; clear the SRAM
memlitz 0x00				; stoire zeroes
sublita 1					; decrement byte count	
zeroa						; byte count = zero?
brnz clearram1				; NO. Continue clearing


; Insert program snippets to be experimented with here **********

litw aw,0x9910				; Ths is an example snippet
addlitw aw,10

halt:
rjmp halt



;**************** Interrupt Handlers ****************************

extint0:


extint1:


pcint_0:


pcint_1:


pcint_2:


wdt:


tim2compa:


tim2compb:


tim2ovf:


tim1capt:


tim1compa:


timicompb:


tim1ovf:


tim0compa:


tim0compb:


tim0ovf:


spistc:


usartrxc:


usartudre:


usarttxc:


adcrdy:


eeready:


anacomp:


twi:


spmrdy:





.include "common_subs_01.asm"
