
; ************************************************* Common subroutines for AVR assembler programming ********************************************

; ********************************** These subroutines supplement the basic macros for AVR assembler programming *****************************

; *************************************************** Release 4.1, March 31, 2019 *****************************************************


; Timing subroutines

.equ millicount=994 	; Timing constant to provide for one millisecond by calling the mikros subroutine in the millis waiting loop. 
						; The example value is valid for a clock frequency of 16 MHz. Modify, if requirend 

mikros:					; Provide for a delay of <AW> microseconds			
sbiw r24,1				; The number of microseconds is expected in the A register = r24, r25
nop						; The routime must be modified according to the clock frequency
nop						; The example is valid for a clock frequency of 16 MHz
nop						; Verify the delay by simulation or experimentally
nop						; Add or remove NOPs as required
nop
nop
nop
nop
nop
nop
nop
nop
brne mikros
ret



millis:					; Provide for a delay of <AW> milliseconds
push r24				; The number of milliseconds is expected in the A register = r24, r25
push r25
lita millicount			; Provide for a delay of ine millisecond
rcall mikros			
pop r25
pop r24
sbiw r24,1
brne millis
ret
